#ifndef SINGLEPLAYERGAME_H
#define SINGLEPLAYERGAME_H

#include <string>
#include <list>

#include "Exception.h"
#include "LevelReader.h"

//----------------------------------------------------------------------------
class SinglePlayerGame
{
  public:
    //------------------------------------------------------------------------
    ~SinglePlayerGame();

    //------------------------------------------------------------------------
    inline bool hasMoreLevels() const
    {
        return m_levelIter != m_levelReader.end();
    }

    //------------------------------------------------------------------------
    inline const std::string &getMission() const
    {
        return m_mission;
    }

    //------------------------------------------------------------------------
    const std::string &nextLevel();

    //------------------------------------------------------------------------
    static void init(const char *mission)
        throw (Exception);

    //------------------------------------------------------------------------
    static void destroy();

    //------------------------------------------------------------------------
    static inline SinglePlayerGame *getInstance()
    {
        return sm_instance;
    }

  protected:

    //------------------------------------------------------------------------
    SinglePlayerGame(const char *mission);

  private:

    //------------------------------------------------------------------------
    static SinglePlayerGame *sm_instance;

    std::string m_mission;
    LevelReader m_levelReader;
    LevelReader::iterator m_levelIter;
};

#endif //SINGLEPLAYERGAME_H
