#ifndef LEVEL_SELECT_MENU_H
#define LEVEL_SELECT_MENU_H

#include "Menu.h"
#include "MissionSelectWidget.h"
#include "ReplaceableSurfaceWidget.h"


class LevelSelectorMenu : public Menu
{
    friend class MissionSelectWidget;

    MENU_SINGLETON(LevelSelector);

  public:
    void eventShow();
    void eventHide();

    inline MissionSelectWidget* getMissionSelect()
    {
        return m_missionSelect;
    }

  protected:

    PARAGUI_CALLBACK(onGo);
    PARAGUI_CALLBACK(onHighscore);
    PARAGUI_CALLBACK(onBack);
    PARAGUI_CALLBACK(onPreviousLevel);
    PARAGUI_CALLBACK(onNextLevel);
    PARAGUI_CALLBACK(onFirstLevel);
    PARAGUI_CALLBACK(onLastLevel);

    void createPreview();
    void updateLevelSelection();

  private:

    void initMissionSelect() throw(GuiException);

    MissionSelectWidget *m_missionSelect;
    ReplaceableSurfaceWidget *m_previewWidget;
};

#endif // LEVEL_SELECT_MENU_H
