#ifndef MISSION_SELECT_WIDGET
#define MISSION_SELECT_WIDGET

#include <pglistbox.h>
#include <pgdropdown.h>
#include <iostream>
#include <vector>

class MissionSelectWidget : public PG_DropDown
{
    public:

        MissionSelectWidget(PG_Widget *parent, const PG_Rect& r)
            : PG_DropDown(parent, 9000, r) 
            { 
                SetIndent(20); 
                SetTransparency(0);
            }
        virtual ~MissionSelectWidget() {}

        inline void pushBackMission(const std::string &name,
                                    const std::string &fullName,
                                    const size_t numberOfLevels)
        {
            m_levelNames.push_back(name);
            m_fullLevelNames.push_back(fullName);
            m_numberOfLevels.push_back(numberOfLevels);
        }

        inline void clear()
        {
            m_levelNames.clear();
            m_fullLevelNames.clear();
            m_numberOfLevels.clear();
        }

        inline const std::string &getCurrentlySelected() const
        {
            return m_levelNames[m_selected];
        }

        inline const std::string &getCurrentlySelectedFull() const
        {
            return m_fullLevelNames[m_selected];
        }

        inline size_t getCurrentlySelectedNumberOfLevels() const
        {
            return m_numberOfLevels[m_selected];
        }

        inline size_t getCurrentlySelectedNum() const
        {
            return m_selected;
        }

        inline size_t getEntrySize() const
        {
            return m_levelNames.size();
        }

        inline void selectFirstItem()
        {
            my_DropList->SelectFirstItem();
        }

        inline void selectItem(PG_ListBoxBaseItem *item)
        {
            my_DropList->SelectItem(item);
        }

        inline PG_ListBoxBaseItem* getSelectedItem()
        {
            return my_DropList->GetSelectedItem();
        }

    protected:

        bool eventSelectItem(PG_ListBoxBaseItem* item);
    
        std::vector<std::string> m_levelNames;
        std::vector<std::string> m_fullLevelNames;
        std::vector<size_t> m_numberOfLevels;

        size_t m_selected;
};

#endif // MISSION_SELECT_WIDGET
